
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class V1::ComplaintReasonsController < ApplicationController
  before_action :set_complaint_reason, only:[:show, :update, :destroy]
  before_action :authenticate_user!, only: [:create, :update]

  # GET v1/complaint_reasons
  # GET v1/complaint_reasons.json
  def index
    complaint_reasons = ComplaintReason.all
    render json: complaint_reasons
  end

  # GET /v1/complaint_reasons/1
  # GET /v1/complaint_reasons/1.json
  def show
    render :json => @complaint_reason
  end

  # POST v1/complaint_reasons
  # POST v1/complaint_reasons.json
  def create

    @complaint_reason = ComplaintReason.new(complaint_reason_params)

    if @complaint_reason.save
      render json: @complaint_reason, status: :created, description: @complaint_reason
    else
      render json: @complaint_reason.errors, status: :unprocessable_entity
    end
  end

  # PATCH/PUT /questions/1
  def update
    if @complaint_reason.update_attribute(:status, complaint_reason_params[:status])
      render json: @complaint_reason
    else
      render json: @complaint_reason.errors, status: :unprocessable_entity
    end
  end

  # DELETE /questions/1
  def destroy
    @complaint_reason.destroy
  end

  private

  def complaint_reason_params
    params.require(:complaint_reason).permit(:reason, :status)
  end

  def set_complaint_reason
    @complaint_reason = ComplaintReason.where(id: params[:id]).first
    
    render status: :not_found if @complaint_reason.blank?

    @complaint_reason
  end
end
