
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class V1::ProgressesController < ApplicationController
  include ::Paginator

  before_action :set_progress, only: :show
  before_action :authenticate_user!, only: :index

	def index
    progresses = paginate current_user.progresses
		render json: progresses, each_serializer: ProgressSerializer
	end

	def show
		render json: @progress, serializer: ProgressSerializer
	end

  private

  def set_progress
    @progress ||= Progress.find_by_id(params[:id])
    if @progress.blank?
      render status: :not_found
    end
  end

end
