
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

class TeacherMailer < ApplicationMailer
  default to: 'integrada.contato@mec.gov.br'

  def new_teacher_received(teacher)
    @teacher = teacher
    mail(subject: "Novo professor cadastrado")
  end

  def teacher_update_received(teacher)
    @teacher = teacher
    mail(subject: "Professor cadastrado atualizado")
  end

  def new_teacher_approved(user)
    @teacher = user
    mail(from: "integrada.contato@mec.gov.br", to: @teacher.email, subject: "Cadastro como professor aprovado")
  end

  def new_teacher_rejected(user)
    @teacher = user
    mail(from: "integrada.contato@mec.gov.br", to: @teacher.email, subject: "Cadastro como professor rejeitado")
  end
end
