
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

# == Schema Information
#
# Table name: downloads
#
#  id                :integer          not null, primary key
#  downloadable_id   :integer
#  downloadable_type :string
#  user_id           :integer
#  created_at        :datetime         not null
#  updated_at        :datetime         not null
#  ip                :string           not null

class Download < ApplicationRecord
  # *current_user* download *downloadable*
  include Trackable

  after_create :create_action

  belongs_to :downloadable, polymorphic: true, counter_cache: true
  belongs_to :user, optional: true

  validates :ip, :downloadable, presence: true

  def recipient
    downloadable
  end

  private

  def new_create_activity
    new_activity(:create) unless user.nil?
  end

  def create_action
    user.complete_action(Action.find_by_name("Fazer Download de um Recurso")) if !user.nil? && downloadable_type == "LearningObject"
  end
end
