
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

# == Schema Information
#
# Table name: roles
#
#  id          :integer          not null, primary key
#  name        :string
#  description :text
#  created_at  :datetime         not null
#  updated_at  :datetime         not null
#

class Role < ApplicationRecord
  has_and_belongs_to_many :users
  has_and_belongs_to_many :emails
  has_and_belongs_to_many :achievements

  validates :name, presence: true, uniqueness: true

  def self.admin
    find_by(name: 'admin') || create!(name: 'admin')
  end

  def self.teacher
    find_by(name: 'teacher') || create!(name: 'teacher')
  end

  def self.student
    find_by(name: 'student') || create!(name: 'student')
  end

  def self.curator
    find_by(name: 'curator') || create!(name: 'curator')
  end

  def self.moderator
    find_by(name: 'moderator') || create!(name: 'moderator')
  end

  def self.editor
    find_by(name: 'editor') || create!(name: 'editor')
  end

  def self.supervisor
    find_by(name: 'supervisor') || create!(name: 'supervisor')
  end

  def self.submitter
    find_by(name: 'submitter') || create!(name: 'submitter')
  end

  def self.partner
    find_by(name: 'partner') || create!(name: 'partner')
  end

  def self.publisher
    find_by(name: 'publisher') || create!(name: 'publisher')
  end

end
