class CreateActionCounters < ActiveRecord::Migration[6.0]
  def change
    create_table :action_counters do |t|
      t.references :user, foreign_key: true
      t.references :action, foreign_key: true
      t.integer :counter, default: 0

      t.timestamps
    end
    add_index :action_counters, [:user_id, :action_id], unique: true, name: 'user_action_index'
  end
end
