
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

def achievements
  main_achievements = [
    { name: "Introduzido Nível I", description: "Assistir ao vídeo de apresentação na plataforma", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Introduzido Nível II", description: "Completar atividades básicas na plataforma", reward_experience: 75, reward_points: 50, state: 1, repeatable: 0, resettable: false },

    { name: "Personalizado", description: "Personalizar seu perfil", reward_experience: 75, reward_points: 50, state: 1, repeatable: 0, resettable: false },

    { name: "Professor", description: "Ser autenticado como professor", reward_experience: 75, reward_points: 100, state: 1, repeatable: 0, resettable: false },

    { name: "Frequente Nível I", description: "Acessar a plataforma por 5 dias consecutivos", reward_experience: 75, reward_points: 50, state: 1, repeatable: 0, resettable: true },
    { name: "Frequente Nível II", description: "Acessar a plataforma por 15 dias consecutivos", reward_experience: 75, reward_points: 50, state: 1, repeatable: 0, resettable: true },
    { name: "Frequente Nível III", description: "Acessar a plataforma por 60 dias consecutivos", reward_experience: 75, reward_points: 50, state: 1, repeatable: 0, resettable: true },
    { name: "Frequente Nível IV", description: "Acessar a plataforma por 120 dias consecutivos", reward_experience: 75, reward_points: 50, state: 1, repeatable: 0, resettable: true },
    { name: "Frequente Nível V", description: "Acessar a plataforma por 365 dias consecutivos", reward_experience: 75, reward_points: 100, state: 1, repeatable: 0, resettable: true },

    { name: "Nostálgico Nível I", description: "Usuário há 6 meses", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Nostálgico Nível II", description: "Usuário há 1 ano", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Nostálgico Nível III", description: "Usuário há 2 anos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Nostálgico Nível IV", description: "Usuário há 3 anos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Nostálgico Nível V", description: "Usuário há 4 anos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },

    { name: "Contribuidor Nível I", description: "Publicar 1 recurso", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Contribuidor Nível II", description: "Publicar 10 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Contribuidor Nível III", description: "Publicar 50 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Contribuidor Nível IV", description: "Publicar 200 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Contribuidor Nível V", description: "Publicar 1000 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },

    { name: "Dias Produtivos Nível I", description: "Publicar 2 recursos em um dia", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: true },
    { name: "Dias Produtivos Nível II", description: "Publicar 5 recursos em um dia", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: true },
    { name: "Dias Produtivos Nível III", description: "Publicar 10 recursos em um dia", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: true },
    { name: "Dias Produtivos Nível IV", description: "Publicar 20 recursos em um dia", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: true },
    { name: "Dias Produtivos Nível V", description: "Publicar 50 recursos em um dia", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: true },

    { name: "Utilizador Assíduo Nível I", description: "Utilizar 10 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Utilizador Assíduo Nível II", description: "Utilizar 50 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Utilizador Assíduo Nível III", description: "Utilizar 200 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Utilizador Assíduo Nível IV", description: "Utilizar 1000 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Utilizador Assíduo Nível V", description: "Utilizar 5000 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },

    { name: "Colecionador Nível I", description: "Utilizar 5 coleções", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Colecionador Nível II", description: "Utilizar 30 coleções", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Colecionador Nível III", description: "Utilizar 100 coleções", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Colecionador Nível IV", description: "Utilizar 1000 coleções", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },

    { name: "Curador Nível I", description: "Avaliar 20 recursos com estrelas e comentários", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Curador Nível II", description: "Avaliar 200 recursos com estrelas e comentários", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Curador Nível III", description: "Avaliar 500 recursos com estrelas e comentários", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Curador Nível IV", description: "Avaliar 1000 recursos com estrelas e comentários", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    # { name: "Curador Nível V", description: "Avaliar 5000 recursos com estrelas e comentários", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },

    { name: "Curador Assíduo Nível I", description: "Avaliar 10 recursos com estrelas e comentários em um dia", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: true },
    { name: "Curador Assíduo Nível II", description: "Avaliar 20 recursos com estrelas e comentários em um dia", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: true },
    { name: "Curador Assíduo Nível III", description: "Avaliar 50 recursos com estrelas e comentários em um dia", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: true },

    { name: "Conectado Nível I", description: "Seguir 10 usuários", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Conectado Nível II", description: "Seguir 50 usuários", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Conectado Nível III", description: "Seguir 200 usuários", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },

    { name: "Conhecido Nível I", description: "Ter 10 seguidores", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Conhecido Nível II", description: "Ter 50 seguidores", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Conhecido Nível III", description: "Ter 200 seguidores", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },

    { name: "Divulgador Nível I", description: "Compartilhar 1 recurso", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Divulgador Nível II", description: "Compartilhar 20 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false },
    { name: "Divulgador Nível III", description: "Compartilhar 100 recursos", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false }
  ]
  subject_achievements = []
  Subject.all.each do |subject|
    subject_achievements << { name: "Proficiência em #{subject.name} Nível I", description: "Utilizar 20 recursos de #{subject.name}", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false }
    subject_achievements << { name: "Proficiência em #{subject.name} Nível II", description: "Utilizar 50 recursos de #{subject.name}", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false }
    subject_achievements << { name: "Proficiência em #{subject.name} Nível III", description: "Utilizar 150 recursos de #{subject.name}", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false }
    subject_achievements << { name: "Proficiência em #{subject.name} Nível IV", description: "Utilizar 500 recursos de #{subject.name}", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false }
    subject_achievements << { name: "Proficiência em #{subject.name} Nível V", description: "Utilizar 1000 recursos de #{subject.name}", reward_experience: 75, reward_points: 10, state: 1, repeatable: 0, resettable: false }
  end
  main_achievements + subject_achievements
end

# xp 0 - 75

achievements.each do |achievement|
  Achievement.where(achievement).first_or_create
end
