
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

require 'acceptance_helpers'

resource 'Action_Counters' do
    header 'Accept', 'application/json'
    header 'Content-Type', 'application/json'

    explanation "A counter for pre-actions in the system done from Users"

    before { 12.times { create(:action_counter) } }

    let(:action_counter) { ActionCounter.all }

    get '/v1/action_counters' do

        parameter :limit, 'Limit of actions'
        parameter :offset, 'Offset of actions'

        let(:limit) { 12 }
        let(:offset) { 0 }

        example_request 'Get a list of action counters' do
                expect( JSON.parse(response_body).map { |o| o['id'] }.sort ).to eq( ActionCounter.limit(limit).offset(offset).pluck(:id).sort ) 
            
            expect(status).to eq(200)
        end
    end

    get '/v1/action_counters/:id' do
        let(:id) { action_counter.first.id }

        example 'Get an action counter' do
            do_request
            expect(path).to eq("/v1/action_counters/#{id}")
            expect(response_body).to eq(Helper.serialize(ActionCounter.find(id)))
            expect(status).to eq(200)
        end
    end
end