
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

require 'acceptance_helpers'
require 'shared/contexts'

resource 'Statistics' do
  before { 12.times { create(:learning_object) } }

	explanation "Statistics about the system usage (total number of published learning objects, 
								number of learning objects published in a month and number of learning objects downloaded in a month)"

  let(:learning_objects) { LearningObject.all }

  get '/v1/statistics' do

    before do
      create(:download, user: @user, downloadable: learning_objects.first)
    end

    example 'Showing plataform statistics' do
      do_request
      expect(status).to eq(200)
    end
  end

end
