
# Copyright (C) 2015 Centro de Computacao Cientifica e Software Livre
# Departamento de Informatica - Universidade Federal do Parana
#
# This file is part of portalmec.
#
# portalmec is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# portalmec is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with portalmec.  If not, see <http://www.gnu.org/licenses/>.

FactoryBot.define do
  factory :collection do |f|
    owner
    f.name { Faker::University.name }
    f.description { Faker::Lorem.sentence }
    f.privacy { "public" }

    transient do
      tags_count { 5 }
      subjects_count { 2 }
      educational_stages_count { 1 }
      collection_items_count { 3 }

    end

    after(:create) do |collection, evaluator|
      create_list(:tagging, evaluator.tags_count, taggable: collection)
      create_list(:collection_item, evaluator.collection_items_count, collection: collection)
      [Subject, EducationalStage].each do |model|
        table = model.to_s.tableize
        collection.try(table.to_sym) << model.all.sample(evaluator.try("#{table}_count".to_sym))
      end
    end
  end
end
